# Tests

Run all tests from the base of the phyddle project directory by calling

```
pytest -s tests
```

The `pytest` command will execute all Python functions with names that begin with 
`test` across all source files in the `tests` directory.

Tests run phyddle code to either (1) verify functions return the correct value
and/or (2) verify that functions produce files with the correct content.

The `tests/workspace` directory contains previously generated files, including
simulated datasets, trained networks, etc. Files stored in the e.g. 
`tests/workspace/simulate/test` directory are generated by `pytest` calls. The 
`pytest` calls verify that results in e.g. `tests/workspace/simulate/test` agree
with previously computed results stored in e.g. `tests/workspace/simulate/valid`.

To regenerate `valid` output:
(1) Set `ENABLE_TEST = False` in `test_pipeline.py`
(2) Run `pytest tests` and verify all tests pass
(3) Change directory to `./tests`
(4) Run `regenerate.py`
(5) Revert `ENABLE_TEST = True` in `test_pipeline.py`
(6) Run `pytest tests` and verify all tests pass


